﻿/*  АЦП на USBUART 
Раз уж это CDC USB устройство которое только прикидывается COM портом, то и обращаться придется к нему соответственно:
копим (c частотой 10 кГц) до 63 байт и скармливаем их USBUART.

*/

#include <device.h>

uint8 DMADone_flag = 0; //Флаг прерыавния (ISR_DMADone.c)

void main()
{
uint16 sample16[31];      // Назначаем ячейки  для значения АЦП  (<64)
uint8 *ADC_sample;    // Буфер значения АЦП(2*n байт) для отправки в USBUART
uint8 n = 0; 
  
CYGlobalIntEnable;    // прерывания потребуются USBUART
ISR_DMA_Done_Start(); // По этому прерыванию отсылаем отсчет АЦП в  USBUART
Clock_1_Start();  

ADC_DelSig_Start();  // Start ADC */ 
ADC_DelSig_IRQ_Disable();    /* The ADC Interrupt is disabled because the system doesn't need the interrupt */
ADC_DelSig_StartConvert();    /* Start ADC conversion */

USBUART_1_Start(0, USBUART_1_5V_OPERATION); //старт и инициализация  USBUART
while(!USBUART_1_bGetConfiguration());

USBUART_1_Init();


	for(;;)
    {
	  			if(DMADone_flag)  //Прерывание от АЦП
		{
        DMADone_flag=0;    // сбросим флаг прерывания
        sample16[n++] = ADC_DelSig_GetResult16(); //Копим  показания АЦП
                     
      if(n==31)
                {
		        n = 0;
          	    ADC_sample = (uint8*)(&sample16);    // Получаем указатель на 1-й из 2-х байт АЦП (преобразуя int16 в int8 )							
		        USBUART_1_Write(ADC_sample,62);       // Отправим 62 байта в USBUART
		        while(!USBUART_1_bTxIsReady()){}		/* Wait for Tx to finish */
		        }	
            }
	    }
 }
/* [] END OF FILE */
